<template>
    <div class="flex justify-end p-2 mb-1">
  <Link v-if="type === 'observer'" href="/performance/observationNote/create" class="font-medium text-lime-500 hover:text-lime-600">
    <button class="btn bg-blue-700 text-white text-sm md:text-base py-2 md:py-3 px-4 md:px-6 font-medium rounded-lg hover:bg-blue-800 focus:outline-none focus:ring-2 focus:ring-blue-500">
      Add an Observation
    </button>
  </Link>
</div>

    <div class="relative shadow-md sm:rounded-lg w-[90vw] md:w-full">
       
        <div class="overflow-auto">
            <table class="w-full table-fixed  text-sm text-left rtl:text-right text-gray-500 dark:text-gray-400 border-collapse">
                <thead class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
                    <tr >
                        <th scope="col" class="p-4 w-16" v-if="type === 'observer'">
                            <!-- <button id="dropdownDefaultButton" data-dropdown-toggle="dropdown-table" type="button"
                                data-dropdown-placement="bottom-start" data-dropdown-offset-distance="16"
                                data-dropdown-offset-skidding="-16">
                                <Icon icon="fa-solid fa-ellipsis-vertical" class="text-xl"></Icon>
                            </button> -->
                        </th>
                        <th scope="col" class="p-4 w-60 md:w-auto">Type</th>
                        <th scope="col" class="p-4 w-60 md:w-auto">Observer</th>
                        <th scope="col" class="p-4 w-60 md:w-auto">Subject</th>
                        <th scope="col" class="p-4 w-60 md:w-auto">Action</th>
                    </tr>
                </thead>
                <tbody>
                    <!-- Table rows -->
                    <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700 hover:bg-gray-50 dark:hover:bg-gray-600"
                        v-for="observationNote in observationNotes.data">
                        <td class="mb-5 p-4" v-if="type === 'observer'">
                            <!-- <div class="flex items-center">
                                <input type="checkbox" class="checkbox" :value="observationNote.id"
                                    v-model="selectionForm.selected" />
                            </div> -->
                        </td>
                        <td class="p-4 dark:text-gray-200"
                            :class="observationNote.type === 'Appreciation Note' ? 'text-lime-500' : 'text-red-600'">
                            {{ observationNote.type }}
                        </td>
                        <td class="p-4 dark:text-gray-200">
                            {{ observationNote.observer.name }} ({{ observationNote.observer.role.name }})
                        </td>
                        <td class="p-4 dark:text-gray-200">
                            {{ observationNote.subject.name }} ({{ observationNote.subject.role.name }})
                        </td>
                        <td class="p-4 flex items-center">
                            <Link :href="type === 'observer' ? `/performance/observationNote/${observationNote.id}` : `/performance/myPerformance/${observationNote.id}`"
                                class="text-gray-500 hover:text-green-900">
                            <Icon icon="fa-solid fa-eye" class="text-2xl"></Icon>
                            </Link>

                            <div class="mx-3"></div>
                        
                            <button  @click="deleteObservationNote(observationNote.id)" v-if="currentUser.role.delete_user">
                                 <Icon icon="fa-trash-can" class="text-xl cursor-pointer"></Icon>
                            </button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>

    <!-- Dropdown menu -->
    <div id="dropdown-table"
        class="z-10 hidden bg-white divide-y divide-gray-100 shadow-md border border-gray-300 w-44 dark:bg-gray-700">
        <ul class="py-2 text-sm text-gray-700 dark:text-gray-200" aria-labelledby="dropdownDefaultButton">
            <li>
                <button
                    class="w-full text-start block px-4 py-2 hover:bg-gray-100 dark:hover:bg-gray-600 dark:hover:text-white"
                    @click="
                        selectionForm.selected = observationNotes.data.map(
                            (observationNote) => observationNote.id
                        )
                        ">
                    Select All
                </button>
            </li>
            <li>
                <button :disabled="selectionForm.selected.length === 0"
                    class="w-full text-start block px-4 py-2 hover:bg-gray-100 disabled:opacity-50 dark:hover:bg-gray-600 dark:hover:text-white"
                    @click="selectionForm.selected = []">
                    Deselect All
                </button>
            </li>
            <li>
                <button :disabled="selectionForm.selected.length === 0" @click="deleteObservationNote"
                    class="w-full text-start block px-4 py-2 hover:bg-red-100 disabled:opacity-50 disabled:hover:bg-white dark:hover:bg-gray-600 dark:hover:text-white text-red-500">
                    Delete
                    <span v-if="selectionForm.selected.length">({{ selectionForm.selected.length }})</span>
                </button>
            </li>
        </ul>
    </div>

    <Pagination :data="observationNotes"></Pagination>
</template>
<script setup>
import { computed, onMounted } from "vue";
import { Link, useForm, usePage } from "@inertiajs/vue3";
import Pagination from "@/Components/Pagination.vue";
import { initDropdowns } from "flowbite";

const page = usePage();
const currentUser = computed(() => page.props.currentUser)

const props = defineProps({
    observationNotes: Object,
    type: String
});

onMounted(() => {
    initDropdowns();
});

//selection
const selectionForm = useForm({
    selected: [],
});

function deleteObservationNote(noteId) {
    if (confirm("Are you sure?")) {
        selectionForm.selected.push(noteId);
        selectionForm.delete("/performance/observationNote", {
            preserveScroll: true,
            preserveState: false,
        });
    }
}


</script>
